#include <sys/types.h>
#include <time.h>
#define FMT_LEN ((char *) 0)

unsigned int fmt_ulong(register char *s,register unsigned long u);

time_t secs;
unsigned long nanosecs;
unsigned long u;
struct tm *t;
char num[40];

unsigned int fmt_uint(register char *s, register unsigned int u)
{
  return fmt_ulong(s,u);
}

unsigned int fmt_uint0(char *s,unsigned int u, unsigned int n)
{
  unsigned int len;
  len = fmt_uint(FMT_LEN,u);
  while (len < n) { if (s) *s++ = '0'; ++len; }
  if (s) fmt_uint(s,u);
  return len;
}

unsigned int fmt_ulong(register char *s,register unsigned long u)
{
  register unsigned int len;
  register unsigned long q;
  
  len = 1;
  q = u;
  while (q > 9) { ++len; q /= 10; }
  if (s) {
    s+= len;
    do { *--s = '0' + (u % 10); u /= 10; } while(u);
  }
  return len;
}

struct tm *converttai64(char *tai64)
{
  unsigned int i;
  
  i = 0;
    if (tai64[i] == '@') {
      i++;
      secs = 0;
      nanosecs = 0;
      for (;;) {
        u = tai64[i] - '0';
        if (u >= 10) {
          u = tai64[i] - 'a';
          if (u >= 6) break;
          u += 10;
        }
        secs <<= 4;
        secs += nanosecs >> 28;
        nanosecs &= 0xfffffff;
        nanosecs <<= 4;
        nanosecs += u;
	i++;
	if (i == strlen(tai64)) break;
      }
      secs -= 4611686018427387914ULL;
      t = localtime(&secs);
/*      printf("%s%i",num,fmt_ulong(num,1900 + t->tm_year));
      printf("%s%i",("-",1); printf("%s%i"(num,fmt_uint0(num,1 + t->tm_mon,2));
      out("-",1); out(num,fmt_uint0(num,t->tm_mday,2));
      out(" ",1); out(num,fmt_uint0(num,t->tm_hour,2));
      out(":",1); out(num,fmt_uint0(num,t->tm_min,2));
      out(":",1); out(num,fmt_uint0(num,t->tm_sec,2));
      out(".",1); out(num,fmt_uint0(num,nanosecs,9));  */
    }
  return t;
}
